Subject: bug#32723: [PATCH] Fix erc-autojoin for same channel names on multiple servers

From: Martin Kletzander <[email-masked]>
Date: Mon, 11 May 2020 17:06:54 +0200

On Sun, May 10, 2020 at 09:32:38PM +0200, Kevin Brubeck Unhammer wrote:
>Martin Kletzander <[email-masked]> čálii:
>
>> When auto-joining channel with the same name on
>> multiple channels the auto-join will go over the
>> list of channels and for each one it checks if
>> there is a buffer and alive server process.
>> However it does not check if the server process
>> matches the server being currently processed for
>> auto-joining.
>>
>> This happens since commit "Don't join erc channels
>> doubly"
>>
>> Fix it by checking if the currently processed
>> server matches the erc process name of the already
>> joined channel.
>
>That's not always going to match though. The car's of
>erc-autojoin-channels contain the values of erc-server-announced-name or
>erc-session-server, not the process-name of
>erc-server-process. E.g. when I join my weechat relay,
>erc-session-server is "example.com" and erc-server-announced-name is
>"weechat.relay.irc" while (process-name erc-server-process) is
>"erc-example.com-9001<1>".
>

Oh, I completely forgot what I was doing there, I just know that with this patch
it is fixed for me, even though it might be dependent on various quirks that
just happen on my client (be it joining servers with very different latency, not
using autojoin twice or something completely different).

>Also, the check is against the current erc-server-process (for the
>server being joined). Isn't the intention of the patch to check against
>the candidate buffer's server-process?
>

As I said, I do not remember what exactly was the reason for this particular way
of dealing with it.  I definitely made some mistakes.

>I would expect something like
>
>	      (when (or (not buffer)
>			;; If the same channel is joined on another
>			;; server the best-effort is to just join
>                        (not (with-current-buffer buffer
>                               (or (string-match-p (car l) erc-session-server)
>                                   (string-match-p (car l) erc-session-announced-name))))
>			(not (with-current-buffer buffer
>			       (erc-server-process-alive))))
>		(erc-server-join-channel server chan))
>

If that works, then I'm fine with it. I can test it later on and let you know if
it works for me.

Thanks,
Martin